/*! FASTOCHE v11.2.2 | SPDX-License-Identifier: MIT | License-Filename: LICENSE.md | restricted use (see terms and conditions) */
!function(){"use strict";var t=function(){this.modules={}},e={isActive:{configurable:!0},isLegacy:{configurable:!0}};t.prototype.create=function(t){var e=new t;this.modules[e.type]=e},t.prototype.getModule=function(t){return this.modules[t]},t.prototype.add=function(t,e){this.modules[t].add(e)},t.prototype.remove=function(t,e){this.modules[t].remove(e)},e.isActive.get=function(){return this._isActive},e.isActive.set=function(t){var e=this;if(t!==this._isActive){this._isActive=t;var i=Object.keys(this.modules).map((function(t){return e.modules[t]}));if(t)for(var s=0,n=i;s<n.length;s+=1){n[s].activate()}else for(var r=0,o=i;r<o.length;r+=1){o[r].deactivate()}}},e.isLegacy.get=function(){return this._isLegacy},e.isLegacy.set=function(t){t!==this._isLegacy&&(this._isLegacy=t)},Object.defineProperties(t.prototype,e);var i=new t,s={prefix:"fastoche",namespace:"fastoche",version:"11.2.2"},n=function(t,e,i,s){switch(this.level=t,this.light=e,this.dark=i,s){case"warn":this.logger=console.warn;break;case"error":this.logger=console.error;break;default:this.logger=console.log}},r={color:{configurable:!0}};n.prototype.log=function(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];for(var i=new o(s.namespace),n=0,r=t;n<r.length;n+=1){var a=r[n];i.add(a)}this.print(i)},n.prototype.print=function(t){t.setColor(this.color),this.logger.apply(console,t.getMessage())},r.color.get=function(){return window.matchMedia("(prefers-color-scheme: dark)").matches?this.dark:this.light},Object.defineProperties(n.prototype,r);var o=function(t){this.inputs=["%c"],this.styles=["font-family:fengardoneue","line-height: 1.5"],this.objects=[],t&&this.add(t+" :")};o.prototype.add=function(t){switch(typeof t){case"object":case"function":this.inputs.push("%o "),this.objects.push(t);break;default:this.inputs.push(t+" ")}},o.prototype.setColor=function(t){this.styles.push("color:"+t)},o.prototype.getMessage=function(){return[this.inputs.join(""),this.styles.join(";")].concat(this.objects)};var a={log:new n(0,"#616161","#989898"),debug:new n(1,"#000091","#8B8BFF"),info:new n(2,"#007c3b","#00ed70"),warn:new n(3,"#ba4500","#fa5c00","warn"),error:new n(4,"#D80600","#FF4641","error")},c=function(){var t=this;this.level=2;var e=function(e){var i=a[e];t[e]=function(){for(var e=[],s=arguments.length;s--;)e[s]=arguments[s];t.level<=i.level&&i.log.apply(i,e)},t[e].print=i.print.bind(i)};for(var i in a)e(i)};c.prototype.state=function(){var t=new o;t.add(i),this.log.print(t)},c.prototype.tree=function(){var t=i.getModule("stage");if(t){var e=new o;this._branch(t.root,0,e),this.log.print(e)}},c.prototype._branch=function(t,e,i){var s="";if(e>0){for(var n="",r=0;r<e;r++)n+="    ";s+=n+"└─ "}s+="["+t.id+"] "+t.html,i.add(s),i.add({"@":t}),i.add("\n");for(var o=0,a=t.children;o<a.length;o+=1){var c=a[o];s+=this._branch(c,e+1,i)}};var h=new c,u=function(t){"loading"!==document.readyState?window.requestAnimationFrame(t):document.addEventListener("DOMContentLoaded",t)},l={AUTO:"auto",MANUAL:"manual",RUNTIME:"runtime",LOADED:"loaded",VUE:"vue",ANGULAR:"angular",REACT:"react"},p=function(){this._mode=l.AUTO,this.isStarted=!1,this.starting=this.start.bind(this),this.preventManipulation=!1},d={mode:{configurable:!0}};p.prototype.configure=function(t,e,i){void 0===t&&(t={}),this.startCallback=e;var n=t.production&&(!i||"false"!==i.production);switch(!0){case i&&!isNaN(i.level):h.level=Number(i.level);break;case i&&i.verbose&&("true"===i.verbose||1===i.verbose):h.level=0;break;case n:h.level=999;break;case t.verbose:h.level=0}h.info("version "+s.version),this.mode=t.mode||l.AUTO},d.mode.set=function(t){switch(t){case l.AUTO:this.preventManipulation=!1,e=this.starting,u(e);break;case l.LOADED:this.preventManipulation=!1,u(this.starting);break;case l.RUNTIME:this.preventManipulation=!1,this.start();break;case l.MANUAL:this.preventManipulation=!1;break;case l.VUE:case l.ANGULAR:case l.REACT:this.preventManipulation=!0;break;default:return void h.error("Illegal mode")}var e;this._mode=t,h.info("mode set to "+t)},d.mode.get=function(){return this._mode},p.prototype.start=function(){h.info("start"),this.startCallback()},Object.defineProperties(p.prototype,d);var f=new p,g=function(){this._collection=[]},y={length:{configurable:!0},collection:{configurable:!0}};g.prototype.forEach=function(t){this._collection.forEach(t)},g.prototype.map=function(t){return this._collection.map(t)},y.length.get=function(){return this._collection.length},g.prototype.add=function(t){return!(this._collection.indexOf(t)>-1)&&(this._collection.push(t),this.onAdd&&this.onAdd(),this.onPopulate&&1===this._collection.length&&this.onPopulate(),!0)},g.prototype.remove=function(t){var e=this._collection.indexOf(t);if(-1===e)return!1;this._collection.splice(e,1),this.onRemove&&this.onRemove(),this.onEmpty&&0===this._collection.length&&this.onEmpty()},g.prototype.execute=function(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];for(var i=0,s=this._collection;i<s.length;i+=1){var n=s[i];n&&n.apply(null,t)}},g.prototype.clear=function(){this._collection.length=0},g.prototype.clone=function(){var t=new g;return t._collection=this._collection.slice(),t},y.collection.get=function(){return this._collection},Object.defineProperties(g.prototype,y);var m=function(t){function e(e){t.call(this),this.type=e,this.isActive=!1}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.activate=function(){},e.prototype.deactivate=function(){},e}(g),v=function(t){return s.prefix+"-"+t};v.selector=function(t,e){return void 0===e&&(e="."),""+e+v(t)},(v.attr=function(t){return"data-"+v(t)}).selector=function(t,e){var i=v.attr(t);return void 0!==e&&(i+='="'+e+'"'),"["+i+"]"},v.event=function(t){return s.namespace+"."+t},v.emission=function(t,e){return"emission:"+t+"."+e};var _=function(t,e){return Array.prototype.slice.call(t.querySelectorAll(e))},b=function(t,e){var i=t.parentElement;return i.matches(e)?i:i===document.documentElement?null:b(i,e)},E=function(t,e,i){this.selector=t,this.InstanceClass=e,this.creator=i,this.instances=new g,this.isIntroduced=!1,this._instanceClassName=this.InstanceClass.instanceClassName,this._instanceClassNames=this.getInstanceClassNames(this.InstanceClass),this._property=this._instanceClassName.substring(0,1).toLowerCase()+this._instanceClassName.substring(1);var s=this._instanceClassName.replace(/[^a-zA-Z0-9]+/g,"-").replace(/([A-Z]+)([A-Z][a-z])/g,"$1-$2").replace(/([a-z])([A-Z])/g,"$1-$2").replace(/([0-9])([^0-9])/g,"$1-$2").replace(/([^0-9])([0-9])/g,"$1-$2").toLowerCase();this._attribute=v.attr("js-"+s)},w={instanceClassName:{configurable:!0},instanceClassNames:{configurable:!0},property:{configurable:!0},attribute:{configurable:!0}};E.prototype.getInstanceClassNames=function(t){var e=Object.getPrototypeOf(t);return e&&"Instance"!==e.instanceClassName?this.getInstanceClassNames(e).concat([t.instanceClassName]):[t.instanceClassName]},E.prototype.hasInstanceClassName=function(t){return this._instanceClassNames.indexOf(t)>-1},E.prototype.introduce=function(){this.isIntroduced||(this.isIntroduced=!0,i.getModule("stage").parse(document.documentElement,this))},E.prototype.parse=function(t,e){var i=[];return t.matches&&t.matches(this.selector)&&i.push(t),!e&&t.querySelectorAll&&t.querySelector(this.selector)&&i.push.apply(i,_(t,this.selector)),i},E.prototype.create=function(t){if(t.node.matches(this.selector)){var e=new this.InstanceClass;return this.instances.add(e),e}},E.prototype.remove=function(t){this.instances.remove(t)},E.prototype.dispose=function(){for(var t=this.instances.collection,e=t.length-1;e>-1;e--)t[e]._dispose();this.creator=null},w.instanceClassName.get=function(){return this._instanceClassName},w.instanceClassNames.get=function(){return this._instanceClassNames},w.property.get=function(){return this._property},w.attribute.get=function(){return this._attribute},Object.defineProperties(E.prototype,w);var C=function(t){function e(){t.call(this,"register")}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.register=function(t,e,s){var n=new E(t,e,s);return this.add(n),i.isActive&&n.introduce(),n},e.prototype.activate=function(){for(var t=0,e=this.collection;t<e.length;t+=1){e[t].introduce()}},e.prototype.remove=function(e){e.dispose(),t.prototype.remove.call(this,e)},e}(m),O=0,A=function(t,e){e?this.id=e:(O++,this.id=O),this.node=t,this.attributeNames=[],this.instances=[],this._children=[],this._parent=null,this._projects=[]},N={proxy:{configurable:!0},html:{configurable:!0},parent:{configurable:!0},ascendants:{configurable:!0},children:{configurable:!0},descendants:{configurable:!0}};N.proxy.get=function(){var t=this;if(!this._proxy){this._proxy={id:this.id,get parent(){return t.parent?t.parent.proxy:null},get children(){return t.children.map((function(t){return t.proxy}))}};for(var e=0,i=this.instances;e<i.length;e+=1){var s=i[e];this._proxy[s.registration.property]=s.proxy}}return this._proxy},N.html.get=function(){if(!this.node||!this.node.outerHTML)return"";var t=this.node.outerHTML.indexOf(">");return this.node.outerHTML.substring(0,t+1)},A.prototype.project=function(t){-1===this._projects.indexOf(t)&&this._projects.push(t)},A.prototype.populate=function(){var t=this._projects.slice();this._projects.length=0;for(var e=0,i=t;e<i.length;e+=1){var s=i[e];this.create(s)}},A.prototype.create=function(t){if(!this.hasInstance(t.instanceClassName)){h.debug("create instance of "+t.instanceClassName+" on element ["+this.id+"]");var e=t.create(this);this.instances.push(e),e._config(this,t),this._proxy&&(this._proxy[t.property]=e.proxy)}},A.prototype.remove=function(t){var e=this.instances.indexOf(t);e>-1&&this.instances.splice(e,1),this._proxy&&delete this._proxy[t.registration.property]},N.parent.get=function(){return this._parent},N.ascendants.get=function(){return[this.parent].concat(this.parent.ascendants)},N.children.get=function(){return this._children},N.descendants.get=function(){var t=[].concat(this._children);return this._children.forEach((function(e){return t.push.apply(t,e.descendants)})),t},A.prototype.addChild=function(t,e){return this._children.indexOf(t)>-1?null:(t._parent=this,!isNaN(e)&&e>-1&&e<this._children.length?this._children.splice(e,0,t):this._children.push(t),t)},A.prototype.removeChild=function(t){var e=this._children.indexOf(t);if(-1===e)return null;t._parent=null,this._children.splice(e,1)},A.prototype.emit=function(t,e){for(var s=[],n=0,r=i.getModule("stage").collection;n<r.length;n+=1){var o=r[n];s.push.apply(s,o._emit(t,e))}return s},A.prototype._emit=function(t,e){for(var i=[],s=0,n=this.instances;s<n.length;s+=1){var r=n[s];i.push.apply(i,r._emitter.emit(t,e))}return i},A.prototype.ascend=function(t,e){return this._parent?this._parent._ascend(t,e):[]},A.prototype._ascend=function(t,e){for(var i=[],s=0,n=this.instances;s<n.length;s+=1){var r=n[s];i.push.apply(i,r._ascent.emit(t,e))}return this._parent&&i.push.apply(i,this._parent._ascend(t,e)),i},A.prototype.descend=function(t,e){for(var i=[],s=0,n=this._children;s<n.length;s+=1){var r=n[s];i.push.apply(i,r._descend(t,e))}return i},A.prototype._descend=function(t,e){for(var i=[],s=0,n=this.instances;s<n.length;s+=1){var r=n[s];i.push.apply(i,r._descent.emit(t,e))}for(var o=0,a=this._children;o<a.length;o+=1){var c=a[o];i.push.apply(i,c._descend(t,e))}return i},A.prototype.getInstance=function(t){for(var e=0,i=this.instances;e<i.length;e+=1){var s=i[e];if(s.registration.hasInstanceClassName(t))return s}return null},A.prototype.hasInstance=function(t){return null!==this.getInstance(t)},A.prototype.getDescendantInstances=function(t,e,i){if(!t)return[];for(var s=[],n=0,r=this._children;n<r.length;n+=1){var o=r[n],a=o.getInstance(t);a&&(s.push(a),i)||(e&&o.hasInstance(e)||!o.children.length||s.push.apply(s,o.getDescendantInstances(t,e,i)))}return s},A.prototype.getAscendantInstance=function(t,e){if(!t||!this._parent)return null;var i=this._parent.getInstance(t);return i||(e&&this._parent.hasInstance(e)?null:this._parent.getAscendantInstance(t,e))},A.prototype.dispose=function(){for(var t=this.instances.length-1;t>=0;t--){var e=this.instances[t];e&&e._dispose()}this.instances.length=0,i.remove("stage",this),this.parent.removeChild(this),this._children.length=0,h.debug("remove element ["+this.id+"] "+this.html)},A.prototype.prepare=function(t){-1===this.attributeNames.indexOf(t)&&this.attributeNames.push(t)},A.prototype.examine=function(){var t=this.attributeNames.slice();this.attributeNames.length=0;for(var e=this.instances.length-1;e>-1;e--)this.instances[e].examine(t)},Object.defineProperties(A.prototype,N);var T={CLICK:v.emission("root","click"),KEYDOWN:v.emission("root","keydown"),KEYUP:v.emission("root","keyup")},R={TAB:{id:"tab",value:9},ESCAPE:{id:"escape",value:27},END:{id:"end",value:35},HOME:{id:"home",value:36},LEFT:{id:"left",value:37},UP:{id:"up",value:38},RIGHT:{id:"right",value:39},DOWN:{id:"down",value:40}},D=function(t){return Object.values(R).filter((function(e){return e.value===t}))[0]},x=function(t){function e(){t.call(this,document.documentElement,"root"),this.node.setAttribute(v.attr("js"),!0),this.listen()}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.listen=function(){document.documentElement.addEventListener("click",this.click.bind(this),{capture:!0}),document.documentElement.addEventListener("keydown",this.keydown.bind(this),{capture:!0}),document.documentElement.addEventListener("keyup",this.keyup.bind(this),{capture:!0})},e.prototype.click=function(t){this.emit(T.CLICK,t.target)},e.prototype.keydown=function(t){this.emit(T.KEYDOWN,D(t.keyCode))},e.prototype.keyup=function(t){this.emit(T.KEYUP,D(t.keyCode))},e}(A),P=function(t){function e(){t.call(this,"stage"),this.root=new x,t.prototype.add.call(this,this.root),this.observer=new MutationObserver(this.mutate.bind(this)),this.modifications=[],this.willModify=!1,this.modifying=this.modify.bind(this)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.hasElement=function(t){for(var e=0,i=this.collection;e<i.length;e+=1){if(i[e].node===t)return!0}return!1},e.prototype.getElement=function(t){for(var e=0,i=this.collection;e<i.length;e+=1){var s=i[e];if(s.node===t)return s}var n=new A(t);return this.add(n),h.debug("add element ["+n.id+"] "+n.html),n},e.prototype.getProxy=function(t){return this.hasElement(t)?this.getElement(t).proxy:null},e.prototype.add=function(e){t.prototype.add.call(this,e),this.put(e,this.root)},e.prototype.put=function(t,e){for(var i=0,s=e.children.length-1;s>-1;s--){var n=e.children[s],r=t.node.compareDocumentPosition(n.node);if(r&Node.DOCUMENT_POSITION_CONTAINS)return void this.put(t,n);if(r&Node.DOCUMENT_POSITION_CONTAINED_BY)e.removeChild(n),t.addChild(n,0);else if(r&Node.DOCUMENT_POSITION_PRECEDING){i=s+1;break}}e.addChild(t,i)},e.prototype.activate=function(){this.observer.observe(document.documentElement,{childList:!0,subtree:!0,attributes:!0})},e.prototype.deactivate=function(){this.observer.disconnect()},e.prototype.mutate=function(t){var e=this,i=[];t.forEach((function(t){switch(t.type){case"childList":t.removedNodes.forEach((function(t){return e.dispose(t)})),t.addedNodes.forEach((function(t){return e.parse(t)}));break;case"attributes":if(e.hasElement(t.target)){var s=e.getElement(t.target);s.prepare(t.attributeName),-1===i.indexOf(s)&&i.push(s);for(var n=0,r=s.descendants;n<r.length;n+=1){var o=r[n];-1===i.indexOf(o)&&i.push(o)}}-1===e.modifications.indexOf(t.target)&&e.modifications.push(t.target)}})),i.forEach((function(t){return t.examine()})),this.modifications.length&&!this.willModify&&(this.willModify=!0,window.requestAnimationFrame(this.modifying))},e.prototype.modify=function(){this.willModify=!1;var t=this.modifications.slice();this.modifications.length=0;for(var e=0,i=t;e<i.length;e+=1){var s=i[e];document.documentElement.contains(s)&&this.parse(s)}},e.prototype.dispose=function(t){var e=[];this.forEach((function(i){t.contains(i.node)&&e.push(i)}));for(var i=0,s=e;i<s.length;i+=1){var n=s[i];n.dispose(),this.remove(n)}},e.prototype.parse=function(t,e,s){for(var n=[],r=0,o=e?[e]:i.getModule("register").collection;r<o.length;r+=1)for(var a=o[r],c=0,h=a.parse(t,s);c<h.length;c+=1){var u=h[c],l=this.getElement(u);l.project(a),-1===n.indexOf(l)&&n.push(l)}for(var p=0,d=n;p<d.length;p+=1){d[p].populate()}},e}(m),L=function(t){function e(){t.call(this,"render"),this.rendering=this.render.bind(this),this.nexts=new g}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.activate=function(){window.requestAnimationFrame(this.rendering)},e.prototype.request=function(t){this.nexts.add(t)},e.prototype.render=function(){if(i.isActive&&(window.requestAnimationFrame(this.rendering),this.forEach((function(t){return t.render()})),this.nexts.length)){var t=this.nexts.clone();this.nexts.clear(),t.forEach((function(t){return t.next()}))}},e}(m),S=function(t){function e(){t.call(this,"resize"),this.requireResize=!1,this.resizing=this.resize.bind(this);var e=this.request.bind(this);document.fonts&&document.fonts.ready.then(e),window.addEventListener("resize",e),window.addEventListener("orientationchange",e)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.activate=function(){this.request()},e.prototype.request=function(){this.requireResize||(this.requireResize=!0,window.requestAnimationFrame(this.resizing))},e.prototype.resize=function(){this.requireResize&&(this.forEach((function(t){return t.resize()})),this.requireResize=!1)},e}(m),k=function(t){function e(){t.call(this,"lock"),this._isLocked=!1,this._scrollY=0,this.onPopulate=this.lock.bind(this),this.onEmpty=this.unlock.bind(this)}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={isLocked:{configurable:!0}};return i.isLocked.get=function(){return this._isLocked},e.prototype.lock=function(){if(!this._isLocked){this._isLocked=!0,this._scrollY=window.scrollY;var t=window.innerWidth-document.documentElement.clientWidth;document.documentElement.setAttribute(v.attr("scrolling"),"false"),document.body.style.top=-this._scrollY+"px",this.behavior=getComputedStyle(document.documentElement).getPropertyValue("scroll-behavior"),"smooth"===this.behavior&&(document.documentElement.style.scrollBehavior="auto"),t>0&&document.documentElement.style.setProperty("--scrollbar-width",t+"px")}},e.prototype.unlock=function(){this._isLocked&&(this._isLocked=!1,document.documentElement.removeAttribute(v.attr("scrolling")),document.body.style.top="",window.scrollTo(0,this._scrollY),"smooth"===this.behavior&&document.documentElement.style.removeProperty("scroll-behavior"),document.documentElement.style.removeProperty("--scrollbar-width"))},e.prototype.move=function(t){this._isLocked?(this._scrollY+=t,document.body.style.top=-this._scrollY+"px"):window.scrollTo(0,window.scrollY+t)},Object.defineProperties(e.prototype,i),e}(m),M=function(t){function e(){t.call(this,"load"),this.loading=this.load.bind(this)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.activate=function(){window.addEventListener("load",this.loading)},e.prototype.load=function(){this.forEach((function(t){return t.load()}))},e}(m),j=["fengardoneue","lack"],I=function(t){function e(){t.call(this,"font-swap"),this.swapping=this.swap.bind(this)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.activate=function(){document.fonts&&document.fonts.addEventListener("loadingdone",this.swapping)},e.prototype.swap=function(){var t=j.filter((function(t){return document.fonts.check("16px "+t)}));this.forEach((function(e){return e.swapFont(t)}))},e}(m),G=function(t){function e(){t.call(this,"mouse-move"),this.requireMove=!1,this._isMoving=!1,this.moving=this.move.bind(this),this.requesting=this.request.bind(this),this.onPopulate=this.listen.bind(this),this.onEmpty=this.unlisten.bind(this)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.listen=function(){this._isMoving||(this._isMoving=!0,this.requireMove=!1,document.documentElement.addEventListener("mousemove",this.requesting))},e.prototype.unlisten=function(){this._isMoving&&(this._isMoving=!1,this.requireMove=!1,document.documentElement.removeEventListener("mousemove",this.requesting))},e.prototype.request=function(t){this._isMoving&&(this.point={x:t.clientX,y:t.clientY},this.requireMove||(this.requireMove=!0,window.requestAnimationFrame(this.moving)))},e.prototype.move=function(){var t=this;this.requireMove&&(this.forEach((function(e){return e.mouseMove(t.point)})),this.requireMove=!1)},e}(m),q=function(t){function e(){t.call(this,"hash"),this.handling=this.handle.bind(this),this.getLocationHash()}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={hash:{configurable:!0}};return e.prototype.activate=function(){window.addEventListener("hashchange",this.handling)},e.prototype.deactivate=function(){window.removeEventListener("hashchange",this.handling)},e.prototype._sanitize=function(t){return"#"===t.charAt(0)?t.substring(1):t},i.hash.set=function(t){var e=this._sanitize(t);this._hash!==e&&(window.location.hash=e)},i.hash.get=function(){return this._hash},e.prototype.getLocationHash=function(){var t=window.location.hash;this._hash=this._sanitize(t)},e.prototype.handle=function(t){var e=this;this.getLocationHash(),this.forEach((function(i){return i.handleHash(e._hash,t)}))},Object.defineProperties(e.prototype,i),e}(m),U=function(){i.create(C),i.create(P),i.create(L),i.create(S),i.create(k),i.create(M),i.create(I),i.create(G),i.create(q);var t=i.getModule("register");this.register=t.register.bind(t)},F={isActive:{configurable:!0}};F.isActive.get=function(){return i.isActive},U.prototype.start=function(){h.debug("START"),i.isActive=!0},U.prototype.stop=function(){h.debug("STOP"),i.isActive=!1},Object.defineProperties(U.prototype,F);var H=new U,z=function(){};z.prototype.getColor=function(t,e,i,s){void 0===s&&(s={});var n="--"+t+"-"+e+"-"+i+B(s);return getComputedStyle(document.documentElement).getPropertyValue(n).trim()||null};var B=function(t){switch(!0){case t.hover:return"-hover";case t.active:return"-active";default:return""}},V=new z,K=function(t){return"."===t.charAt(0)?t.substr(1):t},W=function(t){switch(!0){case!t.className:return[];case"string"==typeof t.className:return t.className.split(" ");case"string"==typeof t.className.baseVal:return t.className.baseVal.split(" ")}return[]},Y=function(t,e,i){e=K(e);var s=W(t),n=s.indexOf(e);!0===i?n>-1&&s.splice(n,1):-1===n&&s.push(e),t.className=s.join(" ")},$=function(t,e){return Y(t,e)},X=function(t,e){return Y(t,e,!0)},Z=function(t,e){return W(t).indexOf(K(e))>-1},J=['[tabindex]:not([tabindex="-1"])',"a[href]","button:not([disabled])","input:not([disabled])","select:not([disabled])","textarea:not([disabled])","audio[controls]","video[controls]",'[contenteditable]:not([contenteditable="false"])',"details>summary:first-of-type","details","iframe"].join(),Q=function(t){return t.querySelectorAll(J)},tt=0,et=function(t){if(!document.getElementById(t))return t;for(var e=!0,i=t;e;)t=i+"-"+ ++tt,e=document.getElementById(t);return t},it={addClass:$,hasClass:Z,removeClass:X,queryParentSelector:b,querySelectorAllArray:_,queryActions:Q,uniqueId:et},st=function(t,e){void 0===t&&(t=0),void 0===e&&(e=0),this._width=t,this._height=e,this._content=""},nt={width:{configurable:!0},height:{configurable:!0},content:{configurable:!0}};nt.width.get=function(){return this._width},nt.width.set=function(t){this._width=t},nt.height.get=function(){return this._height},nt.height.set=function(t){this._height=t},nt.content.get=function(){return this._content},nt.content.set=function(t){this._content=t},st.prototype.getDataURI=function(t){void 0===t&&(t=!1);var e="<svg xmlns='http://www.w3.org/2000/svg' viewbox='0 0 "+this._width+" "+this._height+"' width='"+this._width+"px' height='"+this._height+"px'>"+this._content+"</svg>";return e=e.replace(/#/gi,"%23"),t&&(e=(e=(e=(e=(e=e.replace(/</gi,"%3C")).replace(/>/gi,"%3E")).replace(/"/gi,"'")).replace(/{/gi,"%7B")).replace(/}/gi,"%7D")),"data:image/svg+xml;charset=utf8,"+e},Object.defineProperties(st.prototype,nt);var rt={DataURISVG:st},ot={supportLocalStorage:function(){try{return"localStorage"in window&&null!==window.localStorage}catch(t){return!1}},supportAspectRatio:function(){return!!window.CSS&&CSS.supports("aspect-ratio: 16 / 9")}},at={TransitionSelector:{NONE:v.selector("transition-none")}},ct=function(t){for(var e=[],i=arguments.length-1;i-- >0;)e[i]=arguments[i+1];return e.forEach((function(e){var i=Object.keys(e).reduce((function(t,i){return t[i]=Object.getOwnPropertyDescriptor(e,i),t}),{});Object.getOwnPropertySymbols(e).forEach((function(t){var s=Object.getOwnPropertyDescriptor(e,t);s.enumerable&&(i[t]=s)})),Object.defineProperties(t,i)})),t},ht={completeAssign:ct},ut={},lt={};Object.defineProperty(lt,"isLegacy",{get:function(){return i.isLegacy}}),lt.setLegacy=function(){i.isLegacy=!0},ut.legacy=lt,ut.dom=it,ut.image=rt,ut.support=ot,ut.motion=at,ut.property=ht,ut.ns=v,ut.register=H.register,ut.state=i,ut.query=function(t){if(t&&t.search){var e=new URLSearchParams(window.location.search).entries();return Object.fromEntries(e)}return null}(window.location),Object.defineProperty(ut,"preventManipulation",{get:function(){return f.preventManipulation}}),Object.defineProperty(ut,"stage",{get:function(){return i.getModule("stage")}});var pt=function(t){return i.getModule("stage").getProxy(t)};pt.version=s.version,pt.prefix=s.prefix,pt.organisation=s.organisation,pt.Modes=l,Object.defineProperty(pt,"mode",{set:function(t){f.mode=t},get:function(){return f.mode}}),pt.internals=ut,pt.version=s.version,pt.start=H.start,pt.stop=H.stop,pt.inspector=h,pt.colors=V;var dt=window[s.namespace];pt.internals.configuration=dt,f.configure(dt,pt.start,pt.internals.query),window[s.namespace]=pt;var ft=function(){this.emissions={}};ft.prototype.add=function(t,e){if("function"!=typeof e)throw new Error("closure must be a function");this.emissions[t]||(this.emissions[t]=[]),this.emissions[t].push(e)},ft.prototype.remove=function(t,e){if(this.emissions[t])if(e){var i=this.emissions[t].indexOf(e);i>-1&&this.emissions[t].splice(i)}else delete this.emissions[t]},ft.prototype.emit=function(t,e){if(!this.emissions[t])return[];for(var i=[],s=0,n=this.emissions[t];s<n.length;s+=1){var r=n[s];r&&i.push(r(e))}return i},ft.prototype.dispose=function(){this.emissions=null};var gt=function(t,e){this.id=t,this.minWidth=e};gt.prototype.test=function(){return window.matchMedia("(min-width: "+this.minWidth+"em)").matches};var yt={XS:new gt("xs",0),SM:new gt("sm",36),MD:new gt("md",48),LG:new gt("lg",62),XL:new gt("xl",78)},mt=function(t){void 0===t&&(t=!0),this.jsAttribute=t,this._isRendering=!1,this._isResizing=!1,this._isScrollLocked=!1,this._isLoading=!1,this._isSwappingFont=!1,this._isEnabled=!0,this._isDisposed=!1,this._listeners={},this._handlingClick=this.handleClick.bind(this),this._hashes=[],this._hash="",this._keyListenerTypes=[],this._keys=[],this.handlingKey=this.handleKey.bind(this),this._emitter=new ft,this._ascent=new ft,this._descent=new ft,this._registrations=[],this._nexts=[]},vt={proxy:{configurable:!0},hash:{configurable:!0},isEnabled:{configurable:!0},isRendering:{configurable:!0},isResizing:{configurable:!0},isScrollLocked:{configurable:!0},isLoading:{configurable:!0},isSwappingFont:{configurable:!0},isMouseMoving:{configurable:!0},isDisposed:{configurable:!0},style:{configurable:!0},classNames:{configurable:!0},hasFocus:{configurable:!0},isLegacy:{configurable:!0}},_t={instanceClassName:{configurable:!0}};_t.instanceClassName.get=function(){return"Instance"},mt.prototype._config=function(t,e){this.element=t,this.registration=e,this.node=t.node,this.id=t.node.id,this.jsAttribute&&this.setAttribute(e.attribute,!0),this.init()},mt.prototype.init=function(){},vt.proxy.get=function(){var t=this;return ct({render:function(){return t.render()},resize:function(){return t.resize()}},{get node(){return this.node},get isEnabled(){return t.isEnabled},set isEnabled(e){t.isEnabled=e}})},mt.prototype.log=function(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];t.unshift(this.registration.instanceClassName+" #"+this.id+" - "),h.log.apply(h,t)},mt.prototype.debug=function(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];t.unshift(this.registration.instanceClassName+" #"+this.id+" - "),h.debug.apply(h,t)},mt.prototype.info=function(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];t.unshift(this.registration.instanceClassName+" #"+this.id+" - "),h.info.apply(h,t)},mt.prototype.warn=function(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];t.unshift(this.registration.instanceClassName+" #"+this.id+" - "),h.warn.apply(h,t)},mt.prototype.error=function(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];t.unshift(this.registration.instanceClassName+" #"+this.id+" - "),h.error.apply(h,t)},mt.prototype.register=function(t,e){var s=i.getModule("register").register(t,e,this);this._registrations.push(s)},mt.prototype.getRegisteredInstances=function(t){for(var e=0,i=this._registrations;e<i.length;e+=1){var s=i[e];if(s.hasInstanceClassName(t))return s.instances.collection}return[]},mt.prototype.dispatch=function(t,e,i,s){var n=new CustomEvent(t,{detail:e,bubble:!0===i,cancelable:!0===s});this.node.dispatchEvent(n)},mt.prototype.listen=function(t,e,i){this._listeners[t]||(this._listeners[t]=[]);var s=this._listeners[t],n=new Et(this.node,t,e,i);s.push(n),n.listen()},mt.prototype.unlisten=function(t,e,i){var s=this;if(t){var n=this._listeners[t];if(n)if(e){var r=n.filter((function(t){return t.closure===e&&t.matchOptions(i)}));r.forEach((function(t){return t.unlisten()})),this._listeners[t]=n.filter((function(t){return-1===r.indexOf(t)}))}else n.forEach((function(e){return s.unlisten(t,e.closure)}))}else for(var o in this._listeners)this.unlisten(o)},mt.prototype.listenClick=function(t){this.listen("click",this._handlingClick,t)},mt.prototype.unlistenClick=function(t){this.unlisten("click",this._handlingClick,t)},mt.prototype.handleClick=function(t){},vt.hash.set=function(t){i.getModule("hash").hash=t},vt.hash.get=function(){return i.getModule("hash").hash},mt.prototype.listenHash=function(t,e){if(this._hashes){0===this._hashes.length&&i.add("hash",this);var s=new Ct(t,e);this._hashes=this._hashes.filter((function(e){return e.hash!==t})),this._hashes.push(s)}},mt.prototype.unlistenHash=function(t){this._hashes&&(this._hashes=this._hashes.filter((function(e){return e.hash!==t})),0===this._hashes.length&&i.remove("hash",this))},mt.prototype.handleHash=function(t,e){if(this._hashes)for(var i=0,s=this._hashes;i<s.length;i+=1){s[i].handle(t,e)}},mt.prototype.listenKey=function(t,e,i,s,n){void 0===i&&(i=!1),void 0===s&&(s=!1),void 0===n&&(n="down"),-1===this._keyListenerTypes.indexOf(n)&&(this.listen("key"+n,this.handlingKey),this._keyListenerTypes.push(n)),this._keys.push(new bt(n,t,e,i,s))},mt.prototype.unlistenKey=function(t,e){var i=this;this._keys=this._keys.filter((function(i){return i.code!==t||i.closure!==e})),this._keyListenerTypes.forEach((function(t){i._keys.some((function(e){return e.type===t}))||i.unlisten("key"+t,i.handlingKey)}))},mt.prototype.handleKey=function(t){for(var e=0,i=this._keys;e<i.length;e+=1){i[e].handle(t)}},vt.isEnabled.get=function(){return this._isEnabled},vt.isEnabled.set=function(t){this._isEnabled=t},vt.isRendering.get=function(){return this._isRendering},vt.isRendering.set=function(t){this._isRendering!==t&&(t?i.add("render",this):i.remove("render",this),this._isRendering=t)},mt.prototype.render=function(){},mt.prototype.request=function(t){this._nexts.push(t),i.getModule("render").request(this)},mt.prototype.next=function(){var t=this._nexts.slice();this._nexts.length=0;for(var e=0,i=t;e<i.length;e+=1){var s=i[e];s&&s()}},vt.isResizing.get=function(){return this._isResizing},vt.isResizing.set=function(t){this._isResizing!==t&&(t?(i.add("resize",this),this.resize()):i.remove("resize",this),this._isResizing=t)},mt.prototype.resize=function(){},mt.prototype.isBreakpoint=function(t){return!0==("string"==typeof t)?yt[t.toUpperCase()].test():t.test()},vt.isScrollLocked.get=function(){return this._isScrollLocked},vt.isScrollLocked.set=function(t){this._isScrollLocked!==t&&(t?i.add("lock",this):i.remove("lock",this),this._isScrollLocked=t)},vt.isLoading.get=function(){return this._isLoading},vt.isLoading.set=function(t){this._isLoading!==t&&(t?i.add("load",this):i.remove("load",this),this._isLoading=t)},mt.prototype.load=function(){},vt.isSwappingFont.get=function(){return this._isSwappingFont},vt.isSwappingFont.set=function(t){this._isSwappingFont!==t&&(t?i.add("font-swap",this):i.remove("font-swap",this),this._isSwappingFont=t)},mt.prototype.swapFont=function(){},vt.isMouseMoving.get=function(){return this._isMouseMoving},vt.isMouseMoving.set=function(t){this._isMouseMoving!==t&&(t?i.add("mouse-move",this):i.remove("mouse-move",this),this._isMouseMoving=t)},mt.prototype.mouseMove=function(t){},mt.prototype.examine=function(t){this.node.matches(this.registration.selector)?this.mutate(t):this._dispose()},mt.prototype.mutate=function(t){},mt.prototype.retrieveNodeId=function(t,e){if(t.id)return t.id;var i=et(this.id+"-"+e);return this.warn("add id '"+i+"' to "+e),t.setAttribute("id",i),i},vt.isDisposed.get=function(){return this._isDisposed},mt.prototype._dispose=function(){this.debug("dispose instance of "+this.registration.instanceClassName+" on element ["+this.element.id+"]"),this.removeAttribute(this.registration.attribute),this.unlisten(),i.remove("hash",this),this._hashes=null,this._keys=null,this.isRendering=!1,this.isResizing=!1,this._nexts=null,i.getModule("render").nexts.remove(this),this.isScrollLocked=!1,this.isLoading=!1,this.isSwappingFont=!1,this.isMouseMoving=!1,this._emitter.dispose(),this._emitter=null,this._ascent.dispose(),this._ascent=null,this._descent.dispose(),this._descent=null,this.element.remove(this);for(var t=0,e=this._registrations;t<e.length;t+=1){var s=e[t];i.remove("register",s)}this._registrations=null,this.registration.remove(this),this._isDisposed=!0,this.dispose()},mt.prototype.dispose=function(){},mt.prototype.emit=function(t,e){return this.element.emit(t,e)},mt.prototype.addEmission=function(t,e){this._emitter.add(t,e)},mt.prototype.removeEmission=function(t,e){this._emitter.remove(t,e)},mt.prototype.ascend=function(t,e){return this.element.ascend(t,e)},mt.prototype.addAscent=function(t,e){this._ascent.add(t,e)},mt.prototype.removeAscent=function(t,e){this._ascent.remove(t,e)},mt.prototype.descend=function(t,e){return this.element.descend(t,e)},mt.prototype.addDescent=function(t,e){this._descent.add(t,e)},mt.prototype.removeDescent=function(t,e){this._descent.remove(t,e)},vt.style.get=function(){return this.node.style},mt.prototype.addClass=function(t){$(this.node,t)},mt.prototype.removeClass=function(t){X(this.node,t)},mt.prototype.hasClass=function(t){return Z(this.node,t)},vt.classNames.get=function(){return W(this.node)},mt.prototype.remove=function(){this.node.parentNode.removeChild(this.node)},mt.prototype.setAttribute=function(t,e){this.node.setAttribute(t,e)},mt.prototype.getAttribute=function(t){return this.node.getAttribute(t)},mt.prototype.hasAttribute=function(t){return this.node.hasAttribute(t)},mt.prototype.removeAttribute=function(t){this.node.removeAttribute(t)},mt.prototype.setProperty=function(t,e){this.node.style.setProperty(t,e)},mt.prototype.removeProperty=function(t){this.node.style.removeProperty(t)},mt.prototype.focus=function(){this.node.focus()},mt.prototype.blur=function(){this.node.blur()},mt.prototype.focusClosest=function(){var t=this._focusClosest(this.node.parentNode);t&&t.focus()},mt.prototype._focusClosest=function(t){if(!t)return null;var e=[].concat(Q(t));if(e.length<=1)return this._focusClosest(t.parentNode);var i=e.indexOf(this.node);return e[i+(i<e.length-1?1:-1)]},vt.hasFocus.get=function(){return this.node===document.activeElement},mt.prototype.scrollIntoView=function(){var t=this.getRect(),e=i.getModule("lock");t.top<0&&e.move(t.top-50),t.bottom>window.innerHeight&&e.move(t.bottom-window.innerHeight+50)},mt.prototype.matches=function(t){return this.node.matches(t)},mt.prototype.querySelector=function(t){return this.node.querySelector(t)},mt.prototype.querySelectorAll=function(t){return _(this.node,t)},mt.prototype.queryParentSelector=function(t){return b(this.node,t)},mt.prototype.getRect=function(){var t=this.node.getBoundingClientRect();return t.center=t.left+.5*t.width,t.middle=t.top+.5*t.height,t},vt.isLegacy.get=function(){return i.isLegacy},Object.defineProperties(mt.prototype,vt),Object.defineProperties(mt,_t);var bt=function(t,e,i,s,n){this.type=t,this.eventType="key"+t,this.keyCode=e,this.closure=i,this.preventDefault=!0===s,this.stopPropagation=!0===n};bt.prototype.handle=function(t){t.type===this.eventType&&t.keyCode===this.keyCode.value&&(this.closure(t),this.preventDefault&&t.preventDefault(),this.stopPropagation&&t.stopPropagation())};var Et=function(t,e,i,s){this._node=t,this._type=e,this._closure=i,this._options=s},wt={closure:{configurable:!0}};wt.closure.get=function(){return this._closure},Et.prototype.listen=function(){this._node.addEventListener(this._type,this._closure,this._options)},Et.prototype.matchOptions=function(t){var e=this;switch(void 0===t&&(t=null),!0){case null===t:case"boolean"==typeof this._options&&"boolean"==typeof t&&this._options===t:return!0;case Object.keys(this._options).length!==Object.keys(t).length:return!1;case Object.keys(t).every((function(i){return e._options[i]===t[i]})):return!0}return!1},Et.prototype.unlisten=function(){this._node.removeEventListener(this._type,this._closure,this._options)},Object.defineProperties(Et.prototype,wt);var Ct=function(t,e){this.hash=t,this.add=e};Ct.prototype.handle=function(t,e){this.hash===t&&this.add(e)};var Ot={DISCLOSE:v.event("disclose"),CONCEAL:v.event("conceal")},At={RESET:v.emission("disclosure","reset"),ADDED:v.emission("disclosure","added"),RETRIEVE:v.emission("disclosure","retrieve"),REMOVED:v.emission("disclosure","removed"),GROUP:v.emission("disclosure","group"),UNGROUP:v.emission("disclosure","ungroup"),SPOTLIGHT:v.emission("disclosure","spotlight")},Nt=function(t){function e(e,i,s,n){t.call(this),this.type=e,this._selector=i,this.DisclosureButtonInstanceClass=s,this.disclosuresGroupInstanceClassName=n,this.modifier=this._selector+"--"+this.type.id,this._isPristine=!0,this._isRetrievingPrimaries=!1,this._hasRetrieved=!1,this._primaryButtons=[]}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={isEnabled:{configurable:!0},isPristine:{configurable:!0},proxy:{configurable:!0},buttons:{configurable:!0},group:{configurable:!0},isDisclosed:{configurable:!0},isInitiallyDisclosed:{configurable:!0},buttonHasFocus:{configurable:!0},hasFocus:{configurable:!0},primaryButtons:{configurable:!0}},s={instanceClassName:{configurable:!0}};return s.instanceClassName.get=function(){return"Disclosure"},e.prototype.init=function(){this.addDescent(At.RESET,this.reset.bind(this)),this.addDescent(At.GROUP,this.update.bind(this)),this.addDescent(At.UNGROUP,this.update.bind(this)),this.addAscent(At.SPOTLIGHT,this.disclose.bind(this)),this.register('[aria-controls="'+this.id+'"]',this.DisclosureButtonInstanceClass),this.ascend(At.ADDED),this.listenHash(this.id,this._spotlight.bind(this)),this.update()},i.isEnabled.get=function(){return t.prototype.isEnabled},i.isEnabled.set=function(e){this.isEnabled!==e&&(t.prototype.isEnabled=e,e?this.ascend(At.ADDED):this.ascend(At.REMOVED))},i.isPristine.get=function(){return this._isPristine},i.proxy.get=function(){var e=this,i=Object.assign.call(this,t.prototype.proxy,{disclose:e.disclose.bind(e),focus:e.focus.bind(e)});return this.type.canConceal&&(i.conceal=e.conceal.bind(e)),ct(i,{get buttons(){return e.buttons.map((function(t){return t.proxy}))},get group(){var t=e.group;return t?t.proxy:null},get isDisclosed(){return e.isDisclosed}})},i.buttons.get=function(){return this.getRegisteredInstances(this.DisclosureButtonInstanceClass.instanceClassName)},e.prototype.update=function(){this.getGroup(),this.retrievePrimaries()},e.prototype.getGroup=function(){if(this.disclosuresGroupInstanceClassName){var t=this.element.getAscendantInstance(this.disclosuresGroupInstanceClassName,this.constructor.instanceClassName);t&&t.validate(this)?this._group=t:this._group=null}else this._group=null},i.group.get=function(){return this._group},e.prototype.disclose=function(t){return!(!0===this.isDisclosed||!this.isEnabled)&&(this._isPristine=!1,this.isDisclosed=!0,!t&&this.group&&(this.group.current=this),!0)},e.prototype.conceal=function(t,e){return void 0===e&&(e=!0),!1!==this.isDisclosed&&(!(!this.type.canConceal&&this.group&&this.group.current===this)&&(this.isDisclosed=!1,!t&&this.group&&this.group.current===this&&(this.group.current=null),e||this.focus(),this._isPristine||this.descend(At.RESET),!0))},i.isDisclosed.get=function(){return this._isDisclosed},i.isDisclosed.set=function(t){if(this._isDisclosed!==t&&(this.isEnabled||!0!==t)){this.dispatch(t?Ot.DISCLOSE:Ot.CONCEAL,this.type),this._isDisclosed=t,t?this.addClass(this.modifier):this.removeClass(this.modifier);for(var e=0;e<this.buttons.length;e++)this.buttons[e].apply(t)}},i.isInitiallyDisclosed.get=function(){return this.primaryButtons.some((function(t){return t.isInitiallyDisclosed}))},e.prototype.hasRetrieved=function(){return this._hasRetrieved},e.prototype.reset=function(){},e.prototype.toggle=function(t){if(this.type.canConceal)switch(!0){case!t:case this.isDisclosed:this.conceal(!1,!1);break;default:this.disclose()}else this.disclose()},i.buttonHasFocus.get=function(){return this.buttons.some((function(t){return t.hasFocus}))},i.hasFocus.get=function(){return!!t.prototype.hasFocus||(!!this.buttonHasFocus||this.querySelectorAll(":focus").length>0)},e.prototype.focus=function(){this._primaryButtons.length>0&&this._primaryButtons[0].focus()},i.primaryButtons.get=function(){return this._primaryButtons},e.prototype.retrievePrimaries=function(){this._isRetrievingPrimaries||(this._isRetrievingPrimaries=!0,this.request(this._retrievePrimaries.bind(this)))},e.prototype._retrievePrimaries=function(){if(this._isRetrievingPrimaries=!1,this._primaryButtons=this._electPrimaries(this.buttons),!this._hasRetrieved&&0!==this._primaryButtons.length)if(this.retrieved(),this._hasRetrieved=!0,this.applyAbility(!0),this.group)this.group.retrieve();else if(this._isPristine&&this.isEnabled&&!this.group)switch(!0){case this.hash===this.id:this._spotlight();break;case this.isInitiallyDisclosed:this.disclose()}},e.prototype.retrieved=function(){},e.prototype._spotlight=function(){var t=this;this.disclose(),this.request((function(){t.ascend(At.SPOTLIGHT)}))},e.prototype._electPrimaries=function(t){var e=this;return t.filter((function(t){return t.canDisclose&&!e.node.contains(t.node)}))},e.prototype.applyAbility=function(t){void 0===t&&(t=!1);var e=!this._primaryButtons.every((function(t){return t.isDisabled}));this.isEnabled!==e&&(this.isEnabled=e,t||(!this.isEnabled&&this.isDisclosed&&(this.group?this.ascend(At.REMOVED):this.type.canConceal&&this.conceal()),this.isEnabled&&(this.group&&this.ascend(At.ADDED),this.hash===this.id&&this._spotlight())))},e.prototype.dispose=function(){this._group=null,this._primaryButtons=null,t.prototype.dispose.call(this),this.ascend(At.REMOVED)},Object.defineProperties(e.prototype,i),Object.defineProperties(e,s),e}(mt),Tt=function(t){function e(e){t.call(this),this.type=e,this.attributeName=e.ariaState?"aria-"+e.id:v.attr(e.id),this._canDisclose=!1}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={isPrimary:{configurable:!0},canDisclose:{configurable:!0},isDisabled:{configurable:!0},proxy:{configurable:!0},isDisclosed:{configurable:!0},isInitiallyDisclosed:{configurable:!0},dx:{configurable:!0},dy:{configurable:!0}},s={instanceClassName:{configurable:!0}};return s.instanceClassName.get=function(){return"DisclosureButton"},i.isPrimary.get=function(){return this.registration.creator.primaryButtons.includes(this)},i.canDisclose.get=function(){return this._canDisclose},i.isDisabled.get=function(){return this.type.canDisable&&this.hasAttribute("disabled")},e.prototype.init=function(){this._canDisclose=this.hasAttribute(this.attributeName),this._isInitiallyDisclosed=this.isDisclosed,this._isContained=this.registration.creator.node.contains(this.node),this.controlsId=this.getAttribute("aria-controls"),this.registration.creator.retrievePrimaries(),this.listenClick()},i.proxy.get=function(){return Object.assign.call(this,t.prototype.proxy,{focus:this.focus.bind(this)})},e.prototype.handleClick=function(t){this.registration.creator&&this.registration.creator.toggle(this.canDisclose)},e.prototype.mutate=function(t){this._canDisclose=this.hasAttribute(this.attributeName),this.registration.creator.applyAbility(),!this._isApplying&&this.isPrimary&&t.indexOf(this.attributeName)>-1&&this.registration.creator&&(this.isDisclosed?this.registration.creator.disclose():this.type.canConceal&&this.registration.creator.conceal())},e.prototype.apply=function(t){var e=this;this.canDisclose&&(this._isApplying=!0,this.setAttribute(this.attributeName,t),this.request((function(){e._isApplying=!1})))},i.isDisclosed.get=function(){return"true"===this.getAttribute(this.attributeName)},i.isInitiallyDisclosed.get=function(){return this._isInitiallyDisclosed},e.prototype.focus=function(){t.prototype.focus.call(this),this.scrollIntoView()},e.prototype.measure=function(t){var e=this.rect;this._dx=t.x-e.x,this._dy=t.y-e.y},i.dx.get=function(){return this._dx},i.dy.get=function(){return this._dy},Object.defineProperties(e.prototype,i),Object.defineProperties(e,s),e}(mt),Rt={PREVENT_CONCEAL:v.attr.selector("prevent-conceal"),GROUP:v.attr("group")},Dt=function(t){function e(e,i){t.call(this,i),this.disclosureInstanceClassName=e,this._members=[],this._index=-1,this._isRetrieving=!1,this._hasRetrieved=!1,this._isGrouped=!0}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={proxy:{configurable:!0},members:{configurable:!0},length:{configurable:!0},index:{configurable:!0},current:{configurable:!0},hasFocus:{configurable:!0},isGrouped:{configurable:!0},canUngroup:{configurable:!0}},s={instanceClassName:{configurable:!0}};return s.instanceClassName.get=function(){return"DisclosuresGroup"},e.prototype.init=function(){this.addAscent(At.ADDED,this.update.bind(this)),this.addAscent(At.RETRIEVE,this.retrieve.bind(this)),this.addAscent(At.REMOVED,this.update.bind(this)),this.descend(At.GROUP),this._isGrouped="false"!==this.getAttribute(Rt.GROUP),this.update()},i.proxy.get=function(){var e=this,i={set index(t){e.index=t},get index(){return e.index},get length(){return e.length},get current(){var t=e.current;return t?t.proxy:null},get members(){return e.members.map((function(t){return t.proxy}))},get hasFocus(){return e.hasFocus},set isGrouped(t){e.isGrouped=t},get isGrouped(){return e.isGrouped}};return ct.call(this,t.prototype.proxy,i)},e.prototype.validate=function(t){return!0},e.prototype.getMembers=function(){var t=this,e=this.element.getDescendantInstances(this.disclosureInstanceClassName,this.constructor.instanceClassName,!0);this._members=e.filter(this.validate.bind(this)).filter((function(t){return t.isEnabled})),e.filter((function(e){return!t._members.includes(e)})).forEach((function(t){return t.conceal()}))},e.prototype.retrieve=function(t){void 0===t&&(t=!1),this._isRetrieving||this._hasRetrieved&&!t||(this._isRetrieving=!0,this.request(this._retrieve.bind(this)))},e.prototype._retrieve=function(){var t=this;if(this.getMembers(),this._isRetrieving=!1,this._hasRetrieved=!0,this.hash)for(var e=0;e<this.length;e++){var i=this.members[e];if(this.hash===i.id)return this.index=e,this.request((function(){t.ascend(At.SPOTLIGHT)})),e}for(var s=0;s<this.length;s++){if(this.members[s].isInitiallyDisclosed)return this.index=s,s}return this.getIndex()},e.prototype.update=function(){this.getMembers(),this._hasRetrieved&&this.getIndex()},i.members.get=function(){return this._members},i.length.get=function(){return this.members?this.members.length:0},e.prototype.getIndex=function(t){void 0===t&&(t=-1),this._index=void 0;for(var e=t,i=0;i<this.length;i++)if(this.members[i].isDisclosed){e=i;break}return this.index=e,e},i.index.get=function(){return this._index},i.index.set=function(t){if(!(t<-1||t>=this.length||t===this._index)){this._index=t;for(var e=0;e<this.length;e++){var i=this.members[e];t===e?i.isDisclosed||i.disclose(!0):!this.isGrouped&&this.canUngroup||!i.isDisclosed||i.conceal(!0)}this.apply()}},i.current.get=function(){return-1===this._index||isNaN(this._index)?null:this._members[this._index]||null},i.current.set=function(t){this.index=this.members.indexOf(t)},i.hasFocus.get=function(){var t=this.current;return!!t&&t.hasFocus},i.isGrouped.set=function(t){var e=!!t;this._isGrouped!==e&&(this._isGrouped=e,this.setAttribute(Rt.GROUP,!!t),this.update())},i.isGrouped.get=function(){return this._isGrouped},i.canUngroup.get=function(){return!1},e.prototype.mutate=function(t){t.includes(Rt.GROUP)&&(this.isGrouped="false"!==this.getAttribute(Rt.GROUP))},e.prototype.apply=function(){},e.prototype.dispose=function(){t.prototype.dispose.call(this),this.descend(At.UNGROUP),this._members=null},Object.defineProperties(e.prototype,i),Object.defineProperties(e,s),e}(mt),xt={EXPAND:{id:"expanded",ariaState:!0,ariaControls:!0,canConceal:!0,canDisable:!0},SELECT:{id:"selected",ariaState:!0,ariaControls:!0,canConceal:!1,canDisable:!0},OPENED:{id:"opened",ariaState:!1,ariaControls:!0,canConceal:!0,canDisable:!1}},Pt=function(t){function e(){t.call(this,xt.EXPAND)}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={instanceClassName:{configurable:!0}};return i.instanceClassName.get=function(){return"CollapseButton"},Object.defineProperties(e,i),e}(Tt),Lt={COLLAPSE:v.selector("collapse"),COLLAPSING:v.selector("collapsing")},St=function(t){function e(){t.call(this,xt.EXPAND,Lt.COLLAPSE,Pt,"CollapsesGroup")}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={instanceClassName:{configurable:!0}};return i.instanceClassName.get=function(){return"Collapse"},e.prototype.init=function(){t.prototype.init.call(this),this.listen("transitionend",this.transitionend.bind(this))},e.prototype.transitionend=function(t){this.removeClass(Lt.COLLAPSING),this.isDisclosed||(this.isLegacy?this.style.maxHeight="":this.style.removeProperty("--collapse-max-height"))},e.prototype.unbound=function(){this.isLegacy?this.style.maxHeight="none":this.style.setProperty("--collapse-max-height","none")},e.prototype.disclose=function(e){var i=this;if(!0===this.isDisclosed||!this.isEnabled)return!1;this.unbound(),this.request((function(){i.addClass(Lt.COLLAPSING),i.adjust(),i.request((function(){t.prototype.disclose.call(i,e)}))}))},e.prototype.conceal=function(e,i){var s=this;if(!1===this.isDisclosed)return!1;this.request((function(){s.addClass(Lt.COLLAPSING),s.adjust(),s.request((function(){t.prototype.conceal.call(s,e,i)}))}))},e.prototype.adjust=function(){this.setProperty("--collapser","none");var t=this.node.offsetHeight;this.setProperty("--collapse",-t+"px"),this.setProperty("--collapser","")},e.prototype.reset=function(){this.isPristine||(this.isDisclosed=!1)},e.prototype._electPrimaries=function(e){var i=this.element.parent.instances.map((function(t){return t.collapsePrimary})).filter((function(t){return void 0!==t&&e.indexOf(t)>-1}));if(1===i.length)return i;if(1===(e=t.prototype._electPrimaries.call(this,e)).length)return e;var s=e.filter((function(t){return t.dy>=0}));if(s.length>0&&(e=s),1===e.length)return e;var n=Math.min.apply(Math,e.map((function(t){return t.dy}))),r=e.filter((function(t){return t.dy===n}));return r.length>0&&(e=r),1===e.length||e.sort((function(t,e){return Math.abs(e.dx)-Math.abs(t.dx)})),e},Object.defineProperties(e,i),e}(Nt),kt=function(t){function e(){t.call(this,"Collapse")}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={canUngroup:{configurable:!0}},s={instanceClassName:{configurable:!0}};return s.instanceClassName.get=function(){return"CollapsesGroup"},i.canUngroup.get=function(){return!0},Object.defineProperties(e.prototype,i),Object.defineProperties(e,s),e}(Dt),Mt={CHANGE:v("equisized")},jt=function(t){function e(){t.apply(this,arguments)}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={instanceClassName:{configurable:!0}};return i.instanceClassName.get=function(){return"Equisized"},e.prototype.init=function(){this.ascend(Mt.CHANGE)},e.prototype.measure=function(){return this.isLegacy&&(this.style.width="auto"),this.getRect().width},e.prototype.adjust=function(t){this.isLegacy&&(this.style.width=t+"px")},e.prototype.dispose=function(){this.ascend(Mt.CHANGE)},Object.defineProperties(e,i),e}(mt),It=function(t){function e(){t.apply(this,arguments)}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={instanceClassName:{configurable:!0}};return i.instanceClassName.get=function(){return"EquisizedsGroup"},e.prototype.init=function(){this.isResizing=!0,this.isLoading=!0,this.addAscent(Mt.CHANGE,this.resize.bind(this))},e.prototype.load=function(){this.resize()},e.prototype.resize=function(){var t=this.element.getDescendantInstances("Equisized");this.isLegacy||this.style.setProperty("--equisized-width","auto");var e=Math.max.apply(Math,t.map((function(t){return t.measure()})));this.isLegacy?t.forEach((function(t){return t.adjust(e)})):this.style.setProperty("--equisized-width",e+"px")},Object.defineProperties(e,i),e}(mt),Gt={TOGGLE:v.event("toggle")},qt=function(t){function e(){t.apply(this,arguments)}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={pressed:{configurable:!0},proxy:{configurable:!0}},s={instanceClassName:{configurable:!0}};return s.instanceClassName.get=function(){return"Toggle"},e.prototype.init=function(){this.pressed="true"===this.pressed,this.listenClick()},e.prototype.handleClick=function(){this.toggle()},e.prototype.toggle=function(){this.pressed="true"!==this.pressed},i.pressed.get=function(){return this.getAttribute("aria-pressed")},i.pressed.set=function(t){this.setAttribute("aria-pressed",t?"true":"false"),this.dispatch(Gt.TOGGLE,t)},i.proxy.get=function(){var e=this,i=Object.assign.call(this,t.prototype.proxy,{toggle:e.toggle.bind(e)});return ct(i,{get pressed(){return e.pressed},set pressed(t){e.pressed=t}})},Object.defineProperties(e.prototype,i),Object.defineProperties(e,s),e}(mt),Ut=function(t){function e(){t.apply(this,arguments)}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={proxy:{configurable:!0}},s={instanceClassName:{configurable:!0}};return s.instanceClassName.get=function(){return"InjectSvg"},e.prototype.init=function(){this.node&&(this.img=this.node.querySelector("img")),this.isLegacy||this.replace()},i.proxy.get=function(){var e=this;return Object.assign.call(this,t.prototype.proxy,{replace:e.replace.bind(e),restore:e.restore.bind(e)})},e.prototype.fetch=function(){var t=this;this.img&&(this.imgID=this.img.getAttribute("id"),this.imgClass=this.img.getAttribute("class"),this.imgURL=this.img.getAttribute("src"),fetch(this.imgURL).then((function(t){return t.text()})).then((function(e){var i=(new DOMParser).parseFromString(e,"text/html");t.svg=i.querySelector("svg"),t.svg&&t.replace()})))},e.prototype.replace=function(){if(this.svg){this.imgID&&void 0!==this.imgID&&this.svg.setAttribute("id",this.imgID);var t=this.imgURL.match(/[ \w-]+\./)[0];t&&(t=t.slice(0,-1),["dark","light","system"].includes(t)&&(this.svg.innerHTML=this.svg.innerHTML.replaceAll('id="artwork-','id="'+t+"-artwork-"),this.svg.innerHTML=this.svg.innerHTML.replaceAll('"#artwork-','"#'+t+"-artwork-"))),this.imgClass&&void 0!==this.imgClass&&this.svg.setAttribute("class",this.imgClass),this.svg.hasAttribute("xmlns:a")&&this.svg.removeAttribute("xmlns:a"),this.node.setAttribute("data-fastoche-inject-svg",!0);var e,i;e=this.svg,i={"aria-hidden":!0,focusable:!1},Object.keys(i).forEach((function(t){return e.setAttribute(t,i[t])})),this.node.replaceChild(this.svg,this.img)}else this.fetch()},e.prototype.restore=function(){this.img&&this.svg&&(this.node.setAttribute("data-fastoche-inject-svg",!1),this.node.replaceChild(this.img,this.svg))},Object.defineProperties(e.prototype,i),Object.defineProperties(e,s),e}(mt),Ft={INJECT_SVG:"["+v.attr("inject-svg")+"]"},Ht=function(t){function e(){t.apply(this,arguments)}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={proxy:{configurable:!0}},s={instanceClassName:{configurable:!0}};return s.instanceClassName.get=function(){return"Artwork"},e.prototype.init=function(){this.isLegacy&&this.replace()},i.proxy.get=function(){return Object.assign.call(this,t.prototype.proxy,{replace:this.replace.bind(this)})},e.prototype.fetch=function(){var t=this;this.xlink=this.node.getAttribute("href");var e=this.xlink.split("#");this.svgUrl=e[0],this.svgName=e[1];var i=new XMLHttpRequest;i.onload=function(){var e=(new DOMParser).parseFromString(i.responseText,"text/html");t.realSvgContent=e.getElementById(t.svgName),t.realSvgContent&&(t.realSvgContent.classList.add(t.node.classList),t.replace())},i.open("GET",this.svgUrl),i.send()},e.prototype.replace=function(){this.realSvgContent?this.node.parentNode.replaceChild(this.realSvgContent,this.node):this.fetch()},Object.defineProperties(e.prototype,i),Object.defineProperties(e,s),e}(mt),zt={ARTWORK_USE:v.selector("artwork")+" use"},Bt={ASSESS_FILE:""+v.attr.selector("assess-file"),DETAIL:v.attr.selector("assess-file")+' [class$="__detail"], '+v.attr.selector("assess-file")+' [class*="__detail "]'},Vt={UPDATE:v.emission("assess","update"),ADDED:v.emission("assess","added")},Kt=function(t){function e(){t.apply(this,arguments)}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={instanceClassName:{configurable:!0}};return i.instanceClassName.get=function(){return"AssessFile"},e.prototype.init=function(){this.lang=this.getLang(this.node),this.href=this.getAttribute("href"),this.hreflang=this.getAttribute("hreflang"),this.file={},this.gather(),this.addAscent(Vt.ADDED,this.update.bind(this)),this.addDescent(Vt.ADDED,this.update.bind(this))},e.prototype.getFileLength=function(){var t=this;void 0!==this.href?fetch(this.href,{method:"HEAD",mode:"cors"}).then((function(e){t.length=e.headers.get("content-length")||-1,-1===t.length&&h.warn("File size unknown: "+t.href+'\nUnable to get HTTP header: "content-length"'),t.gather()})):this.length=-1},e.prototype.mutate=function(t){-1!==t.indexOf("href")&&(this.href=this.getAttribute("href"),this.getFileLength()),-1!==t.indexOf("hreflang")&&(this.hreflang=this.getAttribute("hreflang"),this.gather())},e.prototype.gather=function(){if(this.isLegacy&&(this.length=-1),this.length){if(this.details=[],this.href){var t=this.parseExtension(this.href);t&&this.details.push(t.toUpperCase())}-1!==this.length&&this.details.push(this.bytesToSize(this.length)),this.hreflang&&this.details.push(this.getLangDisplayName(this.hreflang)),this.update()}else this.getFileLength()},e.prototype.update=function(){this.details&&(this.descend(Vt.UPDATE,this.details),this.ascend(Vt.UPDATE,this.details))},e.prototype.getLang=function(t){return t.lang?t.lang:document.documentElement===t?window.navigator.language:this.getLang(t.parentElement)},e.prototype.parseExtension=function(t){return t.match(/\.(\w{1,9})(?:$|[?#])/)[0].replace(".","")},e.prototype.getLangDisplayName=function(t){if(this.isLegacy)return t;var e=new Intl.DisplayNames([this.lang],{type:"language"}).of(t);return e.charAt(0).toUpperCase()+e.slice(1)},e.prototype.bytesToSize=function(t){if(-1===t)return null;var e=["octets","ko","Mo","Go","To"];"bytes"===this.getAttribute(v.attr("assess-file"))&&(e=["bytes","KB","MB","GB","TB"]);var i=parseInt(Math.floor(Math.log(t)/Math.log(1e3)),10);if(0===i)return t+" "+e[i];var s=t/Math.pow(1e3,i),n=Math.round(100*(s+Number.EPSILON))/100;return String(n).replace(".",",")+" "+e[i]},Object.defineProperties(e,i),e}(mt),Wt=function(t){function e(){t.apply(this,arguments)}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={instanceClassName:{configurable:!0}};return i.instanceClassName.get=function(){return"AssessDetail"},e.prototype.init=function(){this.addDescent(Vt.UPDATE,this.update.bind(this)),this.ascend(Vt.ADDED)},e.prototype.update=function(t){this.node.innerHTML=t.join(" - ")},Object.defineProperties(e,i),e}(mt),Yt=["32x9","16x9","3x2","4x3","1x1","3x4","2x3"],$t=function(t,e){return e.map((function(e){return v.selector(t+"--"+e)})).join(",")},Xt=v.selector("responsive-img")+", "+$t("responsive-img",Yt)+", "+v.selector("responsive-vid")+", "+$t("responsive-vid",["16x9","4x3","1x1"]),Zt={RATIO:v.selector("ratio")+", "+$t("ratio",Yt)+", "+Xt},Jt=window[s.namespace],Qt=function(t){function e(){t.apply(this,arguments)}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={instanceClassName:{configurable:!0}};return i.instanceClassName.get=function(){return"Ratio"},e.prototype.init=function(){if(!Jt.internals.support.supportAspectRatio()){for(var t in this.ratio=16/9,this.classNames)if(this.registration.selector.indexOf(this.classNames[t])>0){var e=this.classNames[t].split("ratio-");e[1]&&(this.ratio=e[1].split("x")[0]/e[1].split("x")[1])}this.isRendering=!0,this.update()}},e.prototype.render=function(){this.getRect().width!==this.currentWidth&&this.update()},e.prototype.update=function(){this.currentWidth=this.getRect().width,this.style.height=this.currentWidth/this.ratio+"px"},Object.defineProperties(e,i),e}(mt),te={TOP:v.selector("placement--top"),RIGHT:v.selector("placement--right"),BOTTOM:v.selector("placement--bottom"),LEFT:v.selector("placement--left")},ee={START:v.selector("placement--start"),CENTER:v.selector("placement--center"),END:v.selector("placement--end")},ie={TOP:"place_top",RIGHT:"place_right",BOTTOM:"place_bottom",LEFT:"place_left"},se={START:"align_start",CENTER:"align_center",END:"align_end"},ne={AUTO:"placement_auto",MANUAL:"placement_manual"},re=function(t){function e(e,i,s,n){void 0===e&&(e=ne.AUTO),void 0===i&&(i=[ie.BOTTOM,ie.TOP,ie.LEFT,ie.RIGHT]),void 0===s&&(s=[se.CENTER,se.START,se.END]),void 0===n&&(n=16),t.call(this),this._mode=e,this._places=i,this._aligns=s,this._safeAreaMargin=n,this._isShown=!1}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={proxy:{configurable:!0},mode:{configurable:!0},place:{configurable:!0},align:{configurable:!0},isShown:{configurable:!0}},s={instanceClassName:{configurable:!0}};return s.instanceClassName.get=function(){return"Placement"},e.prototype.init=function(){this.isResizing=!0},i.proxy.get=function(){var e=this,i=Object.assign.call(this,t.prototype.proxy,{show:e.show.bind(e),hide:e.hide.bind(e)});return ct(i,{get mode(){return e.mode},set mode(t){e.mode=t},get place(){return e.place},set place(t){e.place=t},get align(){return e.align},set align(t){e.align=t},get isShown(){return e.isShown},set isShown(t){e.isShown=t}})},i.mode.get=function(){return this._mode},i.mode.set=function(t){this._mode=t},i.place.get=function(){return this._place},i.place.set=function(t){if(this._place!==t){switch(this._place){case ie.TOP:this.removeClass(te.TOP);break;case ie.RIGHT:this.removeClass(te.RIGHT);break;case ie.BOTTOM:this.removeClass(te.BOTTOM);break;case ie.LEFT:this.removeClass(te.LEFT)}switch(this._place=t,this._place){case ie.TOP:this.addClass(te.TOP);break;case ie.RIGHT:this.addClass(te.RIGHT);break;case ie.BOTTOM:this.addClass(te.BOTTOM);break;case ie.LEFT:this.addClass(te.LEFT)}}},i.align.get=function(){return this._align},i.align.set=function(t){if(this._align!==t){switch(this._align){case se.START:this.removeClass(ee.START);break;case se.CENTER:this.removeClass(ee.CENTER);break;case se.END:this.removeClass(ee.END)}switch(this._align=t,this._align){case se.START:this.addClass(ee.START);break;case se.CENTER:this.addClass(ee.CENTER);break;case se.END:this.addClass(ee.END)}}},e.prototype.show=function(){this.isShown=!0},e.prototype.hide=function(){this.isShown=!1},i.isShown.get=function(){return this._isShown},i.isShown.set=function(t){this._isShown!==t&&this.isEnabled&&(this.isRendering=t,this._isShown=t)},e.prototype.setReferent=function(t){this._referent=t},e.prototype.resize=function(){this.safeArea={top:this._safeAreaMargin,right:window.innerWidth-this._safeAreaMargin,bottom:window.innerHeight-this._safeAreaMargin,left:this._safeAreaMargin,center:.5*window.innerWidth,middle:.5*window.innerHeight}},e.prototype.render=function(){if(this._referent){if(this.rect=this.getRect(),this.referentRect=this._referent.getRect(),this.mode===ne.AUTO)switch(this.place=this.getPlace(),this.place){case ie.TOP:case ie.BOTTOM:this.align=this.getHorizontalAlign();break;case ie.LEFT:case ie.RIGHT:this.align=this.getVerticalAlign()}var t,e;switch(this.place){case ie.TOP:e=this.referentRect.top-this.rect.height;break;case ie.RIGHT:t=this.referentRect.right;break;case ie.BOTTOM:e=this.referentRect.bottom;break;case ie.LEFT:t=this.referentRect.left-this.rect.width}switch(this.place){case ie.TOP:case ie.BOTTOM:switch(this.align){case se.CENTER:t=this.referentRect.center-.5*this.rect.width;break;case se.START:t=this.referentRect.left;break;case se.END:t=this.referentRect.right-this.rect.width}break;case ie.RIGHT:case ie.LEFT:switch(this.align){case se.CENTER:e=this.referentRect.middle-.5*this.rect.height;break;case se.START:e=this.referentRect.top;break;case se.END:e=this.referentRect.bottom-this.rect.height}}this._x===t&&this._y===e||(this._x=t+.5|0,this._y=e+.5|0,this.node.style.transform="translate("+this._x+"px,"+this._y+"px)")}},e.prototype.getPlace=function(){for(var t=0,e=this._places;t<e.length;t+=1){switch(e[t]){case ie.TOP:if(this.referentRect.top-this.rect.height>this.safeArea.top)return ie.TOP;break;case ie.RIGHT:if(this.referentRect.right+this.rect.width<this.safeArea.right)return ie.RIGHT;break;case ie.BOTTOM:if(this.referentRect.bottom+this.rect.height<this.safeArea.bottom)return ie.BOTTOM;break;case ie.LEFT:if(this.referentRect.left-this.rect.width>this.safeArea.left)return ie.LEFT}}return this._places[0]},e.prototype.getHorizontalAlign=function(){for(var t=0,e=this._aligns;t<e.length;t+=1){switch(e[t]){case se.CENTER:if(this.referentRect.center-.5*this.rect.width>this.safeArea.left&&this.referentRect.center+.5*this.rect.width<this.safeArea.right)return se.CENTER;break;case se.START:if(this.referentRect.left+this.rect.width<this.safeArea.right)return se.START;break;case se.END:if(this.referentRect.right-this.rect.width>this.safeArea.left)return se.END}}return this._aligns[0]},e.prototype.getVerticalAlign=function(){for(var t=0,e=this._aligns;t<e.length;t+=1){switch(e[t]){case se.CENTER:if(this.referentRect.middle-.5*this.rect.height>this.safeArea.top&&this.referentRect.middle+.5*this.rect.height<this.safeArea.bottom)return se.CENTER;break;case se.START:if(this.referentRect.top+this.rect.height<this.safeArea.bottom)return se.START;break;case se.END:if(this.referentRect.bottom-this.rect.height>this.safeArea.top)return se.END}}return this._aligns[0]},e.prototype.dispose=function(){this._referent=null,t.prototype.dispose.call(this)},Object.defineProperties(e.prototype,i),Object.defineProperties(e,s),e}(mt),oe=function(t){function e(){t.call(this),this._isShown=!1}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e;var i={placement:{configurable:!0},isShown:{configurable:!0}},s={instanceClassName:{configurable:!0}};return s.instanceClassName.get=function(){return"PlacementReferent"},e.prototype.init=function(){this.registration.creator.setReferent(this),this._placement=this.registration.creator},i.placement.get=function(){return this._placement},i.isShown.get=function(){return this._isShown},i.isShown.set=function(t){this._isShown!==t&&this.isEnabled&&(this._isShown=t,t?this.registration.creator.show():this.registration.creator.hide())},e.prototype.show=function(){this.isShown=!0},e.prototype.hide=function(){this.isShown=!1},Object.defineProperties(e.prototype,i),Object.defineProperties(e,s),e}(mt);pt.core={Instance:mt,Breakpoints:yt,KeyCodes:R,Disclosure:Nt,DisclosureButton:Tt,DisclosuresGroup:Dt,DisclosureType:xt,DisclosureEvent:Ot,DisclosureSelector:Rt,DisclosureEmission:At,Collapse:St,CollapseButton:Pt,CollapsesGroup:kt,CollapseSelector:Lt,RootSelector:{ROOT:":root"},RootEmission:T,Equisized:jt,EquisizedEmission:Mt,Toggle:qt,EquisizedsGroup:It,InjectSvg:Ut,InjectSvgSelector:Ft,Artwork:Ht,ArtworkSelector:zt,AssessFile:Kt,AssessDetail:Wt,AssessEmission:Vt,AssessSelector:Bt,Ratio:Qt,RatioSelector:Zt,Placement:re,PlacementReferent:oe,PlacementAlign:se,PlacementPosition:ie,PlacementMode:ne},pt.internals.register(pt.core.CollapseSelector.COLLAPSE,pt.core.Collapse),pt.internals.register(pt.core.InjectSvgSelector.INJECT_SVG,pt.core.InjectSvg),pt.internals.register(pt.core.RatioSelector.RATIO,pt.core.Ratio),pt.internals.register(pt.core.AssessSelector.ASSESS_FILE,pt.core.AssessFile),pt.internals.register(pt.core.AssessSelector.DETAIL,pt.core.AssessDetail),pt.internals.legacy.setLegacy(),pt.internals.register(pt.core.ArtworkSelector.ARTWORK_USE,pt.core.Artwork)}();
//# sourceMappingURL=core.nomodule.min.js.map
